!
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran code by Henk Krus, 2012
!
subroutine destroy(widget, gdata) bind(C)
!
! static void destroy (GtkWidget*, gpointer)
!
   use iso_c_binding

   use gtk, only: gtk_main_quit

   type(c_ptr), value :: widget, gdata

   write(*,*) 'gtk3: subroutine destroy called'
   ! stop the GTK+ main loop function
   call gtk_main_quit()

end subroutine destroy
!
! for the time being in tools. later perhaps in a module.
!
subroutine g_signal_connect_swapped(instance, detailed_signal, c_handler, data0)
!
! macro functions (#define) are not implemented
!
! #define g_signal_connect_swapped(instance, detailed_signal, c_handler, data) \
!         g_signal_connect_data ((instance), (detailed_signal), (c_handler), (data),
!                                NULL, G_CONNECT_SWAPPED)
!
   use iso_c_binding, only: c_ptr, c_char, c_funptr, c_long, c_null_funptr
   use g,   only: g_signal_connect_data
   use gtk, only: G_CONNECT_SWAPPED

   character(kind=c_char):: detailed_signal(*)
   type(c_ptr)      :: instance
   type(c_funptr)   :: c_handler
   type(c_ptr)      :: data0
   integer(c_long)  :: id

   id = g_signal_connect_data(instance, detailed_signal, c_handler, &
                              data0, c_null_funptr, G_CONNECT_SWAPPED)

   write(*,*) 'gtk3: subroutine g_signal_connect_swapped, handler: ',id

end subroutine

