!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012  
!
program buttons

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  g_signal_connect, &
                  gtk_button_new_with_mnemonic, &
                  gtk_button_set_relief, &
                  GTK_RELIEF_NONE, &
                  GTK_RELIEF_HALF, &
                  GTK_RELIEF_NORMAL, &
                  gtk_widget_destroy, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main, &
                  GTKTRUE => TRUE

   implicit none

   !external destroy
   interface
     subroutine destroy(widget,gdata) bind(C)
       use iso_c_binding
       type(c_ptr), value :: widget, gdata
     end subroutine
   end interface

   type(c_ptr)    :: window, button
   integer(c_int) :: ic

   call gtk_init()

   window = gtk_window_new (GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window,'Buttons'//C_NULL_CHAR)
   call gtk_container_set_border_width(window, 25)
   call gtk_widget_set_size_request(window, 200, 100)

   call g_signal_connect(window, 'destroy'//C_NULL_CHAR, &
                         c_funloc(destroy))

   ! create a new button that has a mnemonic key of Alt+C
   button = gtk_button_new_with_mnemonic('_Close'//C_NULL_CHAR)
   call gtk_button_set_relief(button,GTK_RELIEF_NORMAL)

   ! connect the button to the clicked signal. the callback function
   ! receives the window followed by the button because the arguments
   ! are swapped.
   call g_signal_connect_swapped(button, 'clicked'//C_NULL_CHAR,  &
                                 c_funloc(gtk_widget_destroy),    &
                                 window)

   call gtk_container_add(window,button)
   call gtk_widget_show_all(window)

   call gtk_main()

end program

