!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program panes

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  gtk_grid_new, &
                  gtk_label_new, &
                  gtk_entry_new, &
                  gtk_grid_attach, &
                  gtk_grid_set_row_spacing, &
                  gtk_grid_set_column_spacing, &
                  g_signal_connect, &
                  gtk_button_new_with_label, &
                  GTK_EXPAND, &
                  GTK_SHRINK, &
                  gtk_widget_destroy, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main

   implicit none

   integer :: i
   character(len=1) :: CNULL = C_NULL_CHAR

   interface
     subroutine destroy(widget,gdata) bind(C)
       use iso_c_binding
       type(c_ptr), value :: widget, gdata
     end subroutine
   end interface

   type(c_ptr)    :: window, table, label1, label2, naam

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window,'Tables'//CNULL)
   call gtk_container_set_border_width(window, 10)
  !call gtk_widget_set_size_request(window, 225, 150)

   ! subroutine destroy in tools
   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(destroy))

   table  = gtk_grid_new()
   call gtk_container_set_border_width(table, 5)
   label1 = gtk_label_new('Enter the following information ...'//CNULL)
   label2 = gtk_label_new('Name: '//CNULL)
   naam = gtk_entry_new()

   ! http://developer.gnome.org/gtk3/3.3/GtkGrid.html
   ! attach the two labels and entry widget to their parent container
   ! left  : the column number to attach the left side of child to
   ! top   : the row number to attach the top side of child to
   ! width : the number of columns that child will span
   ! height: the number of rows that child will span
   !    gtk_grid_attach(grid,  child,  left, top, width, height) bind(c)
   call gtk_grid_attach(table, label1, 0,    0,   2,     1)
   call gtk_grid_attach(table, label2, 0,    1,   1,     1)
   call gtk_grid_attach(table, naam,   1,    1,   1,     1)

   ! add five pixels of spacing between every row and every column
   call gtk_grid_set_row_spacing(table, 5)
   call gtk_grid_set_column_spacing(table, 5)

   call gtk_container_add(window, table)
   call gtk_widget_show_all(window)

   call gtk_main()

end program

