!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program panes

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  gtk_grid_new, &
                  gtk_fixed_new, &
                  gtk_fixed_put, &
                  g_signal_connect, &
                  gtk_button_new_with_label, &
                  gtk_widget_destroy, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main, &
                  TRUE, FALSE

   implicit none

   integer :: i
   character(len=1) :: CNULL = C_NULL_CHAR

   interface
     subroutine destroy(widget,gdata) bind(C)
       use iso_c_binding
       type(c_ptr), value :: widget, gdata
     end subroutine
   end interface

   type(c_ptr)    :: window, fixed, button1, button2

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window,'Fixed'//CNULL)
   call gtk_container_set_border_width(window, 10)

   ! subroutine destroy in tools
   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(destroy))

   fixed   = gtk_fixed_new()
   button1 = gtk_button_new_with_label('Pixel by pixel ...'//CNULL)
   button2 = gtk_button_new_with_label('you choose my fate.'//CNULL)

   ! connect the button to the clicked signal. the callback
   ! function recieves the window followed by the
   ! button because the arguments are swapped.
   call g_signal_connect_swapped(button1, 'clicked'//CNULL, &
                                 c_funloc(destroy),         &
                                 window)

   call g_signal_connect_swapped(button2, 'clicked'//CNULL, &
                                 c_funloc(destroy),         &
                                 window)

   ! place two buttons on the GtkFixed container
   call gtk_fixed_put(fixed, button1, 20, 20)
   call gtk_fixed_put(fixed, button2, 40, 50)

   call gtk_container_add(window, fixed)
   call gtk_widget_show_all(window)

   call gtk_main()

end program

