!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program expanders

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  gtk_expander_new_with_mnemonic, &
                  gtk_label_new, &
                  gtk_expander_set_expanded, &
                  g_signal_connect, &
                  gtk_button_new_with_label, &
                  gtk_widget_destroy, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main, &
                  TRUE, FALSE

   implicit none

   integer :: i
   character(len=1) :: CNULL = C_NULL_CHAR

   interface
     subroutine destroy(widget,gdata) bind(C)
       use iso_c_binding
       type(c_ptr), value :: widget, gdata
     end subroutine
   end interface

   type(c_ptr)    :: window, expander, label

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window,'Expander'//CNULL)
   call gtk_container_set_border_width(window, 10)
   call gtk_widget_set_size_request(window, 200, 100)

   ! subroutine destroy in tools
   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(destroy))

   expander = gtk_expander_new_with_mnemonic('Click _Me For More!'//CNULL)
   label    = gtk_label_new('Hide me or show me,'//achar(10)//'that is your choice.'//CNULL)

   call gtk_container_add(expander, label)
   call gtk_expander_set_expanded(expander, TRUE)
   call gtk_container_add(window, expander)

   call gtk_widget_show_all(window)

   call gtk_main()

end program

