!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program handleboxes

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  g_signal_connect, &
                  gtk_handle_box_new, &
                  gtk_label_new, &
                  gtk_handle_box_set_shadow_type, &
                  GTK_SHADOW_IN, &
                  gtk_handle_box_set_handle_position, &
                  GTK_POS_LEFT, &
                  gtk_handle_box_set_snap_edge, &
                  GTK_POS_TOP, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main, &
                  TRUE, FALSE

   implicit none

   integer :: i
   character(len=1) :: CNULL = C_NULL_CHAR

   interface
     subroutine destroy(widget,gdata) bind(C)
       use iso_c_binding
       type(c_ptr), value :: widget, gdata
     end subroutine
   end interface

   type(c_ptr) :: window, handle, label

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window,'Handle Box'//CNULL)
   call gtk_container_set_border_width(window, 10)
   call gtk_widget_set_size_request(window, 200, 100)

   ! subroutine destroy in tools
   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(destroy))

   ! GtkHandleBox widget for detachable window portions
   !
   ! GtkHandleBox has been deprecated. It is very specialized,
   ! lacks features to make it useful and most importantly does not fit
   ! well into modern application design. Do not use it.
   ! There is no replacement.
   !
   handle = gtk_handle_box_new()
   label  = gtk_label_new('Detach Me'//CNULL)

   ! add a shadow to the handle box, set the handle position on
   ! the left and set the snap edge to the top of the widget
   call gtk_handle_box_set_shadow_type(handle, GTK_SHADOW_IN)
   call gtk_handle_box_set_handle_position(handle, GTK_POS_LEFT)
   call gtk_handle_box_set_snap_edge(handle, GTK_POS_TOP)

   call gtk_container_add(handle, label)
   call gtk_container_add(window, handle)
   call gtk_widget_show_all(window)

   call gtk_main()

end program

