!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program togglebuttons

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  g_signal_connect, &
                  gtk_box_new, &
                  GTK_ORIENTATION_VERTICAL, &
                  gtk_toggle_button_new_with_mnemonic, &
                  gtk_widget_set_sensitive, &
                  gtk_box_pack_start, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main, &
                  TRUE, FALSE

   implicit none

   integer :: i
   character(len=1), parameter :: CNULL = C_NULL_CHAR

   interface
     subroutine destroy(widget,gdata) bind(C)
       use iso_c_binding
       type(c_ptr), value :: widget, gdata
     end subroutine
     subroutine button_toggled(toggle,other_toggle) bind(C)
       use iso_c_binding
       type(c_ptr), value :: toggle, other_toggle
     end subroutine
   end interface

   type(c_ptr) :: window, vbox, toggle1, toggle2

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window,'Toggle Buttons'//CNULL)
   call gtk_container_set_border_width(window, 10)
  !call gtk_widget_set_size_request(window, 250, 100)

   ! subroutine destroy in tools
   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(destroy))

   vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 5)

   toggle1 = gtk_toggle_button_new_with_mnemonic &
                                ('_Deactivate the other one!'//CNULL)
   toggle2 = gtk_toggle_button_new_with_mnemonic &
                                ('_No! Deactivate that one!'//CNULL)

   call g_signal_connect(toggle1, 'toggled'//CNULL, &
                         c_funloc(button_toggled), toggle2)
   call g_signal_connect(toggle2, 'toggled'//CNULL, &
                         c_funloc(button_toggled), toggle1)

   call gtk_box_pack_start(vbox, toggle1, TRUE,  TRUE, 5)
   call gtk_box_pack_start(vbox, toggle2, FALSE, TRUE, 5)

   call gtk_container_add(window, vbox)
   call gtk_widget_show_all(window)

   call gtk_widget_set_sensitive(toggle1, TRUE)
   call gtk_widget_set_sensitive(toggle2, TRUE)

   call gtk_main()

end program
subroutine button_toggled(toggle, other_toggle) bind(C)
!
! if the toggle button was activated, set the other as disabled
! otherwise, enable the other toggle button
!
   use iso_c_binding

   use gtk, only: gtk_toggle_button_get_active, &
                  gtk_widget_set_sensitive, &
                  TRUE, FALSE

   type(c_ptr), value :: toggle, other_toggle

   ! note TRUE = 1 not .true.!
   if( gtk_toggle_button_get_active(toggle) == TRUE )then
     call gtk_widget_set_sensitive(other_toggle, FALSE)
   else
     call gtk_widget_set_sensitive(other_toggle, TRUE)
   endif

end subroutine button_toggled

