!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program radiobuttons

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  g_signal_connect, &
                  gtk_widget_destroy, &
                  gtk_radio_button_new_with_label, &
                  gtk_radio_button_new_with_label_from_widget, &
                  gtk_radio_button_new_with_mnemonic_from_widget, &
                  gtk_box_new, &
                  GTK_ORIENTATION_VERTICAL, &
                  gtk_box_pack_start, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main, &
                  TRUE, FALSE

   implicit none

   integer :: i
   character(len=1), parameter :: CNULL = C_NULL_CHAR

   interface
     subroutine destroy(widget,gdata) bind(C)
       use iso_c_binding
       type(c_ptr), value :: widget, gdata
     end subroutine
   end interface

   type(c_ptr) :: window, vbox, radio1, radio2, radio3, radio4

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window,'Radio Buttons'//CNULL)
   call gtk_container_set_border_width(window, 10)

   ! subroutine destroy in tools
   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(destroy))

   ! create 3 radio buttons where the second two join radio1's group
   radio1 = gtk_radio_button_new_with_label(C_NULL_PTR, &
                                    'I want to be clicked!'//CNULL)
   radio2 = gtk_radio_button_new_with_label_from_widget(radio1, &
                                    'Click me instead!'//CNULL)
   radio3 = gtk_radio_button_new_with_mnemonic_from_widget(radio1, &
                                     'No! _Click me!'//CNULL)

   ! the radio button you create the new widget from does not
   ! matter as long as it it already a member of the group!
   radio4 = gtk_radio_button_new_with_label_from_widget(radio3, &
                                     'No! Click me instead!'//CNULL)

   vbox = gtk_box_new(GTK_ORIENTATION_VERTICAL, 5)
   call gtk_container_set_border_width(vbox, 10)
   call gtk_box_pack_start(vbox, radio1,  TRUE, TRUE, 0)
   call gtk_box_pack_start(vbox, radio2,  TRUE, TRUE, 0)
   call gtk_box_pack_start(vbox, radio3,  TRUE, TRUE, 0)
   call gtk_box_pack_start(vbox, radio4,  TRUE, TRUE, 0)

   call gtk_container_add(window, vbox)
   call gtk_widget_show_all(window)

   call gtk_main()

end program

