!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program entries

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  g_signal_connect, &
                  gtk_widget_destroy, &
                  gtk_label_new, &
                  gtk_entry_new, &
                  gtk_entry_set_visibility, &
                  gtk_entry_set_invisible_char, &
                  gtk_box_new, &
                  GTK_ORIENTATION_VERTICAL, &
                  GTK_ORIENTATION_HORIZONTAL, &
                  gtk_box_pack_start, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main, &
                  TRUE, FALSE

   use g, only:   g_get_user_name

   implicit none

   integer :: i
   character(len=1), parameter :: CNULL = C_NULL_CHAR

   interface
     subroutine destroy(widget,gdata) bind(C)
       use iso_c_binding
       type(c_ptr), value :: widget, gdata
     end subroutine
   end interface

   type(c_ptr) :: window, vbox, hbox, radio1, question, label, passwd
   type(c_ptr) :: c_string

   character(len=32) :: fstr, str

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window,'Password?'//CNULL)
   call gtk_container_set_border_width(window, 10)

   ! subroutine destroy in tools
   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(destroy))

   c_string = g_get_user_name()
   call c_f_string(C_string, fstr)

   str = 'What is the password for '//fstr(1:len_trim(fstr))//'?'//CNULL

   question = gtk_label_new(str)
   label    = gtk_label_new('Password:'//CNULL)

   ! create a new GtkEntry widget and hide its content from view
   passwd = gtk_entry_new()
   call gtk_entry_set_visibility(passwd, FALSE)
   call gtk_entry_set_invisible_char(passwd,ichar('x'))

   hbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 5)
   call gtk_box_pack_start(hbox, label,  TRUE, TRUE, 0)
   call gtk_box_pack_start(hbox, passwd, TRUE, TRUE, 0)

   vbox = gtk_box_new(GTK_ORIENTATION_VERTICAL, 5)
   call gtk_container_set_border_width(vbox, 10)
   call gtk_box_pack_start(vbox, question, TRUE, TRUE, 0)
   call gtk_box_pack_start(vbox, hbox,     TRUE, TRUE, 0)

   call gtk_container_add(window, vbox)
   call gtk_widget_show_all(window)

   call gtk_main()

end program

