!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program messagedialogs

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  g_signal_connect, &
                  gtk_main_quit, &
                  gtk_button_new_with_mnemonic, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main

   implicit none

   interface
     subroutine button_clicked(button,parent) bind(c)
       use iso_c_binding
       type(c_ptr) :: button, parent
     end subroutine
   end interface

   integer :: i
   character(len=1), parameter :: CNULL = C_NULL_CHAR

   type(c_ptr) :: window, button

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window, 'Message Dialogs'//CNULL)
   call gtk_container_set_border_width(window, 10)

   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(gtk_main_quit))

   button = gtk_button_new_with_mnemonic('_Click Me'//CNULL)

   call g_signal_connect(button, 'clicked'//CNULL, &
                         c_funloc(button_clicked), window)

   call gtk_container_add(window, button)
   call gtk_widget_show_all(window)

   call gtk_main()

end program
subroutine button_clicked(button,parent) bind(c)

   use iso_c_binding

   use gtk, only: GTK_DIALOG_MODAL, &
                 !gtk_message_dialog_new, &
                  GTK_MESSAGE_INFO, &
                  GTK_BUTTONS_OK, &
                  gtk_window_set_title, &
                  gtk_dialog_run, &
                  gtk_widget_destroy

   interface
     !
     ! function commented out in gtk-auto.f90 and redefined
     !
     ! GtkWidget* gtk_message_dialog_new(GtkWindow *parent,
     !            GtkDialogFlags flags, GtkMessageType type,
     !            GtkButtonsType buttons, const gchar *message_format, ...)
     function gtk_message_dialog_new(parent,flags,mtype,button,mformat) bind(c)
       use iso_c_binding, only: c_ptr, c_int, c_char
       type(c_ptr) :: gtk_message_dialog_new
       type(c_ptr), value :: parent
       integer(c_int), value :: flags
       integer(c_int), value :: button
       integer(c_int), value :: mtype
       character(kind=c_char), dimension(*) :: mformat
     end function
   end interface

   type(c_ptr), intent(in), value :: button, parent
   type(c_ptr) :: dialog

   character(len=1), parameter :: CNULL = C_NULL_CHAR
   integer(c_int) :: id

   dialog = gtk_message_dialog_new(parent, GTK_DIALOG_MODAL, &
                                   GTK_MESSAGE_INFO, GTK_BUTTONS_OK, &
                                  'The button was clicked!'//CNULL)

   call gtk_window_set_title(dialog, 'Information'//CNULL)

   id = gtk_dialog_run(dialog)
   call gtk_widget_destroy(dialog)

end subroutine button_clicked

