!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program savefile

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  g_signal_connect, &
                  gtk_main_quit, &
                  gtk_button_new_with_label, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main

   implicit none

   interface
     subroutine button_clicked(button,window) bind(c)
       use iso_c_binding
       type(c_ptr), value :: button, window
     end subroutine
   end interface
   
   character(len=1), parameter :: CNULL = C_NULL_CHAR

   type(c_ptr) :: window, button

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window, 'Save a File'//CNULL)
   call gtk_container_set_border_width(window, 10)
   call gtk_widget_set_size_request (window, 200, 100)

   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(gtk_main_quit))

   button = gtk_button_new_with_label('Save As ...'//CNULL)

   call g_signal_connect(button, 'clicked'//CNULL, &
                         c_funloc(button_clicked),window)

   call gtk_container_add(window, button)
   call gtk_widget_show_all(window)

   call gtk_main()

end program
subroutine button_clicked(button,window) bind(c)
!
!  allow the user to enter a new file name and location for 
!  the file and set the button to the text of the location
!
   use iso_c_binding

   use gtk, only: GTK_FILE_CHOOSER_ACTION_SAVE, &
                  GTK_RESPONSE_CANCEL, &
                  GTK_RESPONSE_ACCEPT, &
                  gtk_dialog_run, &
                  gtk_file_chooser_get_filename, &
                  gtk_button_set_label, &
                  gtk_widget_destroy

   implicit none

   interface
     function gtk_file_chooser_dialog_new_f03(title,parent,actie, &
              button1,response1,button2,response2,button3,response3)
       use iso_c_binding
       type(c_ptr) :: gtk_file_chooser_dialog_new_f03
       character(len=*), intent(in)           :: title
       type(c_ptr), intent(in), optional      :: parent
       integer(c_int), intent(in)             :: actie
       character(len=*), intent(in), optional :: button1, button2, button3
       integer, intent(in), optional          :: response1, response2, response3
     end function
!
!    GtkWidget *gtk_file_chooser_dialog_new(const gchar *title, 
!               GtkWindow *parent, GtkFileChooserAction action, 
!               const gchar *first_button_text, ...) G_GNUC_NULL_TERMINATED;
!
     function gtk_file_chooser_dialog_new(title,parent,mode, &
              button1,response1,button2,response2,cnull) bind(c)
       use iso_c_binding
       type(c_ptr) :: gtk_file_chooser_dialog_new
       character(kind=c_char), dimension(*) :: title
       type(c_ptr), value                   :: parent
       integer(c_int), value                :: mode
       character(kind=c_char), dimension(*) :: button1, button2
       integer(c_int), value :: response1, response2
       character(kind=c_char), value        :: cnull
     end function
     subroutine f_c_string(f_string, c_string)
       use iso_c_binding, only: c_char, c_null_char
       character(len=*), intent(in) :: f_string
       character(kind=c_char), dimension(:), intent(inout), allocatable :: c_string
     end subroutine
   end interface

   integer :: i, istat
   character(len=1), parameter :: CNULL = C_NULL_CHAR

   type(c_ptr), value :: button, window
   integer(c_int)     :: response
   type(c_ptr)        :: dialog

   character(len=128) :: filename = ' '

   character(len=*), parameter :: GTK_STOCK_SAVE   = 'gtk-save'//CNULL
   character(len=*), parameter :: GTK_STOCK_CANCEL = 'gtk-cancel'//CNULL

   type(c_ptr)        :: c_string_ptr
   character(len=1), dimension(:), target, allocatable :: c_string
!
!  GtkFileChooserAction:
!  @GTK_FILE_CHOOSER_ACTION_OPEN: Indicates open mode.  The file chooser
!    will only let the user pick an existing file.
!  @GTK_FILE_CHOOSER_ACTION_SAVE: Indicates save mode.  The file chooser
!   will let the user pick an existing file, or type in a new filename.
!  @GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER: Indicates an Open mode for
!    selecting folders.  The file chooser will let the user pick an
!    existing folder.
!  @GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER: Indicates a mode for creating a
!    new folder.  The file chooser will let the user name an existing or
!    new folder.
! 

   dialog = gtk_file_chooser_dialog_new('Save File As ...'//CNULL, &
                                        window, &
                                        GTK_FILE_CHOOSER_ACTION_SAVE, &
                                        GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, &
                                        GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT, &
                                        C_NULL_CHAR)

   response = gtk_dialog_run(dialog)

   if( response == GTK_RESPONSE_ACCEPT )then
     c_string_ptr = gtk_file_chooser_get_filename(dialog)
     call c_f_string(c_string_ptr,filename)
     write(*,*) 'file: ',filename(1:len_trim(filename))
     call gtk_button_set_label(button, filename(1:len_trim(filename))//CNULL)
   else
     write(*,*) 'niets noppes nothing nada'
   endif
  
   call gtk_widget_destroy(dialog)

end subroutine button_clicked
function gtk_file_chooser_dialog_new_f03(title, parent, actie, &
                                         button1, response1,   &
                                         button2, response2,   &
                                         button3, response3)
   use iso_c_binding

   use gtk, only: gtk_dialog_new, &
                  gtk_dialog_get_content_area, &
                  gtk_dialog_get_action_area, &
                  gtk_window_set_title, &
                  gtk_label_new, &
                  gtk_box_pack_start, &
                  gtk_container_set_border_width, &
                  gtk_box_set_spacing, &
                  gtk_container_set_border_width, &
                  gtk_window_set_role, &
                  g_signal_connect, &
                  gtk_window_set_transient_for, &
                  gtk_window_set_destroy_with_parent, &
                  gtk_box_new, &
                  GTK_ORIENTATION_VERTICAL, &
                  GTK_ORIENTATION_HORIZONTAL, &
                  gtk_dialog_add_button, &
                  gtk_box_pack_start, &
                  gtk_container_add, &
                  TRUE, FALSE

   interface
     subroutine response_handler(dialog,response) bind(c)
       use iso_c_binding
       type(c_ptr), value    :: dialog
       integer(c_int), value :: response
     end subroutine
   end interface

   integer :: i
   character(len=1), parameter :: CNULL = C_NULL_CHAR

   type(c_ptr) :: gtk_file_chooser_dialog_new_f03
   type(c_ptr) :: dialog

   character(len=*), intent(in)           :: title
   type(c_ptr), intent(in), optional      :: parent
   integer(c_int), intent(in)             :: actie
   character(len=*), intent(in), optional :: button1, button2, button3
   integer, intent(in), optional          :: response1, response2, response3

   type(c_ptr) :: content_area, action_area
   type(c_ptr) :: label,  ib1, ib2, ib3

   dialog = gtk_dialog_new()

   content_area = gtk_dialog_get_content_area(dialog)
   action_area  = gtk_dialog_get_action_area(dialog)

   call gtk_container_set_border_width(dialog, 5)
   call gtk_box_set_spacing(content_area, 2)
   call gtk_container_set_border_width(action_area, 5)
   call gtk_window_set_title(dialog, title(1:len_trim(title))//C_NULL_CHAR)

!  label = gtk_label_new('GtkFileChooserDialog'//CNULL)
!  hbox  = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 5)
!  call gtk_box_pack_start(hbox, label, TRUE, TRUE, 0)
!  call gtk_box_pack_start(content_area, hbox, TRUE, TRUE, 0)

   ! role : unique identifier for the window manager to be
   ! used when restoring a session
   call gtk_window_set_role(dialog, 'GtkFileChooserDialog'//CNULL)

   call g_signal_connect(dialog, 'response'//CNULL, &
                         c_funloc(response_handler))

   if( present(parent) )then
     write(*,*) 'parent present'
     call gtk_window_set_transient_for(dialog, parent)
     call gtk_window_set_destroy_with_parent(dialog, TRUE)
   endif

   if( present(button1) )then
write(*,*)'br1:',button1,response1
     if( present(response1) )then
       ib1 = gtk_dialog_add_button(dialog, &
                                   button1(1:len_trim(button1))//C_NULL_CHAR, &
                                   response1)
     else
       write(*,*) 'error: missing response1'
     endif
   endif
   if( present(button2) )then
write(*,*)'br2:',button2,response2
     if( present(response2) )then
       ib1 = gtk_dialog_add_button(dialog, &
                                   button2(1:len_trim(button2))//C_NULL_CHAR, &
                                   response2)
     else
       write(*,*) 'error: missing response2'
     endif
   endif
   if( present(button3) )then
write(*,*)'br3:',button3,response3
     if( present(response3) )then
       ib1 = gtk_dialog_add_button(dialog, &
                                   button3(1:len_trim(button3))//C_NULL_CHAR, &
                                   response3)
     else
       write(*,*) 'error: missing response3'
     endif
   endif


   gtk_file_chooser_dialog_new_f03 = dialog

end function gtk_file_chooser_dialog_new_f03
subroutine response_handler(dialog, response) bind(c)

   use iso_c_binding

   type(c_ptr), value    :: dialog
   integer(c_int), value :: response
   logical :: is_stock_accept_response_id
   
   ! act only on known reponses
   if( is_stock_accept_response_id(response) )then
     write(*,*) 'response OK: ',response
   else
     write(*,*) 'unknown response ',response
   endif

end subroutine response_handler
logical function is_stock_accept_response_id(response)

   use iso_c_binding, only: c_int

   use gtk, only: GTK_RESPONSE_ACCEPT, &
                  GTK_RESPONSE_OK, &
                  GTK_RESPONSE_YES, &
                  GTK_RESPONSE_APPLY 

   implicit none
   
   integer(c_int), intent(in) :: response

   if( response == GTK_RESPONSE_ACCEPT .or. &
       response == GTK_RESPONSE_OK     .or. &
       response == GTK_RESPONSE_YES    .or. &
       response == GTK_RESPONSE_APPLY )then
     is_stock_accept_response_id = .true.
   else
     is_stock_accept_response_id = .true.
   endif  

end function is_stock_accept_response_id




