!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program createfolder

   use iso_c_binding

   use gtk, only: gtk_init, &
                  GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER, &
                  GTK_RESPONSE_CANCEL, &
                  GTK_RESPONSE_ACCEPT, &
                  GTK_RESPONSE_OK, &
                  gtk_dialog_run, &
                  gtk_file_chooser_get_filename, &
                  gtk_button_set_label, &
                  gtk_widget_destroy

   implicit none

   interface
!
!    GtkWidget *gtk_file_chooser_dialog_new(const gchar *title, 
!               GtkWindow *parent, GtkFileChooserAction action, 
!               const gchar *first_button_text, ...) G_GNUC_NULL_TERMINATED;
!
     function gtk_file_chooser_dialog_new(title,parent,mode, &
              button1,response1,button2,response2,cnull) bind(c)
       use iso_c_binding
       type(c_ptr) :: gtk_file_chooser_dialog_new
       character(kind=c_char), dimension(*) :: title
       type(c_ptr), value                   :: parent
       integer(c_int), value                :: mode
       character(kind=c_char), dimension(*) :: button1, button2
       integer(c_int), value :: response1, response2
       character(kind=c_char), value        :: cnull
     end function
   end interface
   
   character(len=1), parameter :: CNULL = C_NULL_CHAR

   type(c_ptr)    :: dialog
   integer(c_int) :: response

   character(len=128) :: filename = ' '

   character(len=*), parameter :: GTK_STOCK_OK     = 'gtk-ok'//CNULL
   character(len=*), parameter :: GTK_STOCK_SAVE   = 'gtk-save'//CNULL
   character(len=*), parameter :: GTK_STOCK_CANCEL = 'gtk-cancel'//CNULL
 
   type(c_ptr)        :: c_string_ptr

   call gtk_init()

   ! create a new GtkFileChooserDialog that will be used 
   ! to create a new folder
   dialog = gtk_file_chooser_dialog_new('Create a Folder ...'//CNULL, &
                                        C_NULL_PTR, &
                                        GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER, &
                                        GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, &
                                        GTK_STOCK_OK, GTK_RESPONSE_OK, &
                                        C_NULL_CHAR)

   response = gtk_dialog_run(dialog)
   if( response == GTK_RESPONSE_OK )then
     c_string_ptr = gtk_file_chooser_get_filename(dialog)
     call c_f_string(c_string_ptr,filename)
     write(*,*) 'Creating directory: ',filename
   endif
  
   call gtk_widget_destroy(dialog)

end program

