!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program timeouts

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  g_signal_connect, &
                  gtk_main_quit, &
                  gtk_progress_bar_new, &
                  gtk_progress_bar_set_pulse_step, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main

   use g, only:   g_timeout_add

   implicit none

   character(len=1), parameter :: CNULL = C_NULL_CHAR

   interface
     function pulse_progress(progress) bind(c)
       use iso_c_binding
       integer(c_int)     :: pulse_progress
       type(c_ptr), value :: progress
     end function
   end interface

   type(c_ptr)    :: window, progress
   integer(c_int) :: i

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window, 'Timeouts'//CNULL)
   call gtk_container_set_border_width(window, 10)
   call gtk_widget_set_size_request(window, 200, -1)

   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(gtk_main_quit), C_NULL_PTR)

   progress = gtk_progress_bar_new()
   call gtk_progress_bar_set_pulse_step(progress,0.1_c_double)

   i = g_timeout_add(100, c_funloc(pulse_progress), progress)

   call gtk_container_add(window, progress)
   call gtk_widget_show_all(window)

   call gtk_main()

end
function pulse_progress(progress) bind(c)
!
! pulse the progress bar and return TRUE so
! the timeout is called again
!
   use iso_c_binding

   use gtk, only: gtk_progress_bar_pulse

   implicit none

   integer(c_int) :: pulse_progress
   type(c_ptr), value :: progress

   integer, save  :: icnt = 0

   call gtk_progress_bar_pulse(progress)

   icnt = icnt + 1

   if( icnt < 125 )then
     pulse_progress = 1
   else
     pulse_progress = 0
     stop   
   endif

end




