!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2013
!
program images

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  g_signal_connect, &
                  gtk_text_view_new, &
                  gtk_text_view_get_buffer, &
                  gtk_text_buffer_set_text, &
                  gtk_text_buffer_get_iter_at_line, &
                  gtk_text_buffer_insert_pixbuf, &
                  gtk_scrolled_window_new, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main, &
                  gtk_main_quit, &
                  gtkTRUE  => TRUE, &
                  gtkFALSE => FALSE

   use gtk_os_dependent, only: gdk_pixbuf_new_from_file

   implicit none

   ! define a GtkTextIter type
   type, bind(c) :: gtktextiter 
     type(c_ptr) :: d1, d2
     integer(kind=c_int) :: d3, d4, d5, d6, d7, d8
     type(c_ptr) :: d9, d10
     integer(kind=c_int) :: d11, d12, d13
     type(c_ptr) :: d14
   end type gtktextiter

   character(len=1), parameter :: CNULL = C_NULL_CHAR
   character(len=1), parameter :: CR    = C_CARRIAGE_RETURN

   type(c_ptr) :: window, textview, buffer, undo, redo, scrolled_window
   type(gtktextiter), target :: line

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window, 'Pixbufs'//CNULL)
   call gtk_container_set_border_width(window,10)
   call gtk_widget_set_size_request(window, 200, 150)

   call g_signal_connect(window, 'destroy'//CNULL, &
                         c_funloc(gtk_main_quit), C_NULL_PTR)

   textview = gtk_text_view_new()
   buffer   = gtk_text_view_get_buffer(textview)

   call gtk_text_buffer_set_text(buffer, 'Undo'//CR//'Redo'//CNULL, -1)

   ! create two images and insert them into the text buffer
   undo = gdk_pixbuf_new_from_file('undo.png'//CNULL, C_NULL_PTR)
   call gtk_text_buffer_get_iter_at_line(buffer, c_loc(line), 0)

   ! void gtk_text_buffer_insert_pixbuf(GtkTextBuffer *buffer, 
   !                                    GtkTextIter *iter, 
   !                                    GdkPixbuf *pixbuf)
   call gtk_text_buffer_insert_pixbuf(buffer, c_loc(line), undo)

   redo = gdk_pixbuf_new_from_file('redo.png'//CNULL, C_NULL_PTR)
   call gtk_text_buffer_get_iter_at_line(buffer, c_loc(line), 1)
   call gtk_text_buffer_insert_pixbuf(buffer, c_loc(line), redo)

   scrolled_window = gtk_scrolled_window_new(C_NULL_PTR, C_NULL_PTR)
   call gtk_container_add(scrolled_window, textview)
   call gtk_container_add(window, scrolled_window)
   call gtk_widget_show_all(window)

   call gtk_main()

end

