!
! Original program by Andrew Krause
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran version by Henk Krus, 2012
!
program exercise

   use iso_c_binding

   use gtk, only: gtk_init, &
                  gtk_window_new, &
                  GTK_WINDOW_TOPLEVEL, &
                  gtk_window_set_title, &
                  gtk_container_set_border_width, &
                  gtk_widget_set_size_request, &
                  gtk_window_set_resizable, &
                  g_signal_connect, &
                  gtk_label_new, &
                  gtk_label_set_selectable, &
                  gtk_container_add, &
                  gtk_widget_show_all, &
                  gtk_main, &
                  GTKTRUE => TRUE, &
                  GTKFALSE => FALSE

   use g, only:   g_object_set_data, g_object_set_property, &
                  g_object_get_data

   implicit none

  !external my_destroy, my_key_event
   interface
     subroutine my_destroy(widget,gdata) bind(C)
       use iso_c_binding
       type(c_ptr), value :: widget, gdata
     end subroutine
     function my_key_event(window,event,label) bind(C)
       use iso_c_binding
       integer(c_int) :: my_key_event
       type(c_ptr), value :: window, event, label
     end function my_key_event
   end interface

   type(c_ptr) :: window, label, getdata

   character(len=12), pointer :: fptr
   type(c_ptr) :: cptr

   integer :: i, j, k

   integer(c_int), target :: iwidth = 400, iheight = 200, i1, i2

   ! very oldschool but easy and simple
   character(len=11), target :: STRING1
   character(len=11), target :: STRING2
   common/block/ STRING1, STRING2

   character(len=11) :: STRING3
   character(len=1,kind=c_char), dimension(11), target :: STRING4
   character(len=11) :: STRING5

   STRING1 = 'String ONE'//C_NULL_CHAR
   STRING2 = 'String TWO'//C_NULL_CHAR
   STRING3 = 'Some title'//C_NULL_CHAR
   do i=1,11
     STRING4(i) = string3(i:i)
   enddo
   STRING5 = ' '

   call gtk_init()

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL)
   call gtk_window_set_title(window,STRING1)
   call gtk_container_set_border_width(window,10)
   call gtk_widget_set_size_request(window,iwidth,iheight)
  !call gtk_window_set_resizable(window,GTKFALSE)

  !i1 = 400
  !i2 = 200
  !call g_object_set_data(window,'set_width_request'//C_NULL_CHAR,c_loc(i1))
  !call g_object_set_data(window,'height_request'//C_NULL_CHAR,c_loc(i2))

   write(*,*)'Set'
   call g_object_set_data(window,'title'//C_NULL_CHAR,c_loc(string4))

   write(*,*)'Get'
  !gpointer g_object_get_data(GObject *object, const gchar *key)
  !function g_object_get_data(object, key) bind(c)
  ! use iso_c_binding, only: c_ptr, c_char
  ! type(c_ptr) :: g_object_get_data
  ! type(c_ptr), value :: object
  ! character(kind=c_char), dimension(*) :: key
  !end function

   getdata = g_object_get_data(window,'title'//C_NULL_CHAR)

   call c_f_string(getdata,string5)
   write(*,*)'Show >',string5(1:len_trim(string5)),'<'

   ! connect the main window to the destroy signals
   call g_signal_connect(window, 'destroy'//C_NULL_CHAR, &
                         c_funloc(my_destroy))

   ! create a new GtkLabel widget that is selectable
   label = gtk_label_new(STRING2)
   call gtk_label_set_selectable(label,GTKTRUE)

  !call g_signal_connect(window,'key-press-event'//C_NULL_CHAR, &
  !                      c_funloc(my_key_event),label)

   ! add the label as a child widget of the window
   call gtk_container_add (window,label)
   call gtk_widget_show_all(window)

   ! hand control over to the main loop
   call gtk_main()

end program exercise
!==================================================
function my_key_event(window, event, label) bind(C)

   use iso_c_binding

   use gtk, only: gtk_window_set_title, &
                  gtk_label_set_text,   &
                  gtk_label_get_text

   type(c_ptr), value :: window, event, label

   integer(c_int) :: my_key_event
   type(c_ptr) :: pointer_to_c_string
   character(len=512), pointer :: pointer_to_fortran_str

   logical, save :: toggle = .true.

   ! very oldschool but easy and simple
   character(len=11) :: STRING1
   character(len=11) :: STRING2
   common/block/ STRING1, STRING2

   ! G_CONST_RETURN gchar* gtk_label_get_text (GtkLabel *label);
   ! function gtk_label_get_text(label) bind(c)
   !   use iso_c_binding, only: c_ptr
   !   type(c_ptr) :: gtk_label_get_text
   !   type(c_ptr), value :: label
   ! end function

   pointer_to_c_string = gtk_label_get_text(label)
   call c_f_pointer(cptr=pointer_to_c_string, fptr=pointer_to_fortran_str)
   length = min(len(pointer_to_fortran_str), &
                index(pointer_to_fortran_str,char(0)))

   write(*,*) 'Label found is >',pointer_to_fortran_str(1:length),'<'

   if( toggle )then
     call gtk_window_set_title(window,STRING2)
     call gtk_label_set_text(label,STRING1)
   else
     call gtk_window_set_title(window,STRING1)
     call gtk_label_set_text(label,STRING2)
   endif

   toggle = .not. toggle

   write(*,*) 'my_key_event'

   my_key_event = 0 !FALSE

end function my_key_event
subroutine my_destroy(widget, gdata) bind(C)
!
! static void destroy (GtkWidget*, gpointer)
!
   use iso_c_binding

   use gtk, only: gtk_main_quit

   type(c_ptr), value :: widget, gdata

   write(*,*) 'subroutine destroy'
   call gtk_main_quit()

end subroutine my_destroy

