!
! Foundations of GTK+ Development
! Fortran2003 and gtk-fortran code by Henk Krus, 2012
!
subroutine destroy(widget, gdata) bind(C)
!
! static void destroy (GtkWidget*, gpointer)
!
   use iso_c_binding

   use gtk, only: gtk_main_quit

   type(c_ptr), value :: widget, gdata

   write(*,*) 'gtk3: subroutine destroy called'
   ! stop the GTK+ main loop function
   call gtk_main_quit()

end subroutine destroy
!
! for the time being in tools. later perhaps in a module.
!
subroutine g_signal_connect_swapped(instance, detailed_signal, c_handler, data0)
!
! macro functions (#define) are not implemented
!
! #define g_signal_connect_swapped(instance, detailed_signal, c_handler, data) \
!         g_signal_connect_data ((instance), (detailed_signal), (c_handler), (data),
!                                NULL, G_CONNECT_SWAPPED)
!
   use iso_c_binding, only: c_ptr, c_char, c_funptr, c_long, c_null_funptr
   use g,   only: g_signal_connect_data
   use gtk, only: G_CONNECT_SWAPPED

   character(kind=c_char):: detailed_signal(*)
   type(c_ptr)      :: instance
   type(c_funptr)   :: c_handler
   type(c_ptr)      :: data0
   integer(c_long)  :: id

   id = g_signal_connect_data(instance, detailed_signal, c_handler, &
                              data0, c_null_funptr, G_CONNECT_SWAPPED)

   write(*,*) 'gtk3: subroutine g_signal_connect_swapped, handler: ',id

end subroutine
subroutine g_signal_connect_after(instance, detailed_signal, c_handler, data0)
!
! macro functions (#define) are not implemented
!
! #define g_signal_connect_after(instance, detailed_signal, c_handler, data) \
!   g_signal_connect_data ((instance), (detailed_signal), (c_handler), (data), 
!                           NULL, G_CONNECT_AFTER)
!
   use iso_c_binding, only: c_ptr, c_char, c_funptr, c_long, c_null_funptr
   use g,   only: g_signal_connect_data
   use gtk, only: G_CONNECT_AFTER

   character(kind=c_char):: detailed_signal(*)
   type(c_ptr)      :: instance
   type(c_funptr)   :: c_handler
   type(c_ptr)      :: data0
   integer(c_long)  :: id

   id = g_signal_connect_data(instance, detailed_signal, c_handler, &
                              data0, c_null_funptr, G_CONNECT_AFTER)

   write(*,*) 'gtk3: subroutine g_signal_connect_after, handler: ',id

end subroutine
function gtk_is_spin_button(widget)
!
! macro functions (#define) are not implemented
!
! #define GTK_IS_SPIN_BUTTON(obj) \
!         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_TYPE_SPIN_BUTTON))
!
   use iso_c_binding

   integer(c_int) :: gtk_is_spin_button
   type(c_ptr), value :: widget

   interface
     function gtk3cx_is_spin_button(widget) bind(C,name='gtk3zzz')
       use iso_c_binding, only: c_int, c_ptr
       integer(c_int) :: gtk3cx_is_spin_button
       type(c_ptr), value :: widget
     end function
   end interface

  !gtk_is_spin_button = gtk3cx_is_spin_button(widget)
   gtk_is_spin_button = 0
   
end function gtk_is_spin_button
subroutine c_f_string(c_string, f_string)

   use iso_c_binding

   type(c_ptr), intent(in) :: c_string
   character(len=*), intent(out) :: f_string
   character(len=1,kind=c_char), dimension(:), pointer :: ptr_chars
   integer :: i

   if( .not. c_associated(c_string) )then
     f_string = ' '
     !write(*,*) 'c_string not associated'
   else
     call c_f_pointer(c_string,ptr_chars,[128])
     i = 1
     do while( ptr_chars(i) /= C_NULL_CHAR .and. i <= len(F_string) )
       F_string(i:i) = ptr_chars(i)
      !write(*,*)':>',F_string(i:i),'<'
       i = i + 1
     end do
     if( i < len(F_string) ) F_string(i:) = ' '
   endif

   !write(*,*)'=>',F_string(1:len(F_string)),'<='

end subroutine c_f_string
subroutine f_c_string(f_string, c_string)

   use iso_c_binding, only: c_char, c_null_char

   character(len=*), intent(in) :: f_string
   character(kind=c_char), dimension(:), intent(inout), allocatable :: c_string
   integer :: ls, i, istat

   ls = len_trim(f_string)
   if( .not. allocated(c_string) )then
     allocate(c_string(1:ls+1),stat=i)
     if( i /= 0 ) write(*,*)'error allocate 1'
   else
     deallocate(c_string,stat=i)
     if( i /= 0 ) write(*,*)'error deallocate 2'
     allocate(c_string(1:ls+1),stat=i)
     if( i /= 0 ) write(*,*)'error allocate 2'
   endif

   do i=1,ls
     c_string(i) = f_string(i:i)
   enddo
   c_string(ls+1) = C_NULL_CHAR

end subroutine f_c_string

